# 180110 Levenshtein distance, check including indels

setwd("~/Documents/UNI_und_VORLESUNGEN/14 Guelph/1 Fusion primer plates/R script")

#install.packages("stringdist")
library("stringdist")

data <- read.csv("Primers_v2_BF2_3.txt", sep="\t", stringsAsFactors=F)



exp <- read.csv("180110_2197_tags_tab.csv", sep=",", stringsAsFactors=F)



# nucleotide table
upac <- read.csv(text=c("ID,comment,A,T,C,G, comp
A,Adenine,1,0,0,0,T
C,Cytosine,0,0,1,0,G
G,Guanine,0,0,0,1,C
T,Thymine,0,1,0,0,A
R,A or G,0.5,0,0,0.5,Y
Y,C or T,0,0.5,0.5,0,R
S,G or C,0,0,0.5,0.5,S
W,A or T,0.5,0.5,0,0,W
K,G or T,0,0.5,0,0.5,M
M,A or C,0.5,0,0.5,0,K
B,C or G or T,0,0.3,0.3,0.3,V
D,A or G or T,0.3,0.3,0,0.3,H
H,A or C or T,0.3,0.3,0.3,0,D
V,A or C or G,0.3,0,0.3,0.3,B
N,any base,0.25,0.25,0.25,0.25,N
I,inosine,0.25,0.25,0.25,0.25,N
-,gap,0,0,0,0,-"), stringsAsFactors=F)

upac[upac==0.3] <- 1/3


upac2 <- upac
upac2[3:6] <- upac2[3:6]>0
upac2 <- cbind(upac2, "sum"=rowSums(upac2[3:6]))


# evaluate missmatches between tags, based on Tag_mm_v9_blue.R


TagLength <- 7

DNA <- exp$merge

DNA <- data.frame("sequ" = unlist(DNA), stringsAsFactors=F)
row.names(DNA) <- exp$ID

#make substring
#count number of missmatches (minimum 2 mm)
DNA$sequ <- substr(DNA$sequ, 1, TagLength)

data2 <- strsplit(DNA$sequ, "")


k <- 1
# save possible primer combination!

save <- NULL

for (k in 1:nrow(DNA)){
ID <- match(data2[[k]], upac2$ID) # k = tag number

deg <- upac2$sum[ID]
sumdeg <- 1
for (i in 1:length(deg)){ # i = base of tag
sumdeg <- sumdeg*deg[i]
}


save_deg <- NULL
for (i in 1:length(data2[[k]])){

keep <- c("A", "T", "C", "G")[unlist(upac2[ID[i], 3:6])]
if (sumdeg>1){
save_deg <- cbind(save_deg, rep(keep, 1, sumdeg))
save_deg <- save_deg[order(save_deg[,i]),]} else{
save_deg[i] <- upac2$ID[ID[i]]
}

}

if(sumdeg>1){
temp <- cbind(row.names(DNA)[k], DNA[k,], save_deg)}else{
temp <- c(row.names(DNA)[k], DNA[k,], save_deg)
}

save <- rbind(save, temp)

}


# 




# till here!
if(F){
data2 <- save[, -c(1,2)]

same <- function(A, B){
	sum(A==B)
}

n <- 1 
m <- 1

table <- NULL
for(n in 1:nrow(data2)){

temp <- NULL
for (m in 1:nrow(data2)){
temp[m] <- same(data2[n,], data2[m,])
}

table <- cbind(table, temp)
}
}

# end

Tags <- save[,-c(1,2)]

collapsed <- NULL
for (s in 1:nrow(Tags)){
collapsed[s] <- paste(Tags[s,], collapse="")
}

cbind(save, collapsed)

table <- stringdistmatrix(collapsed, collapsed, "lv")


col <- rev(c("white","white","white","white", "lightyellow", "Orange", "Red", "Darkred"))

pdf(paste("test.pdf", sep=""), width=16, height=16)
par(mar=c(12,12,1,1))

lim <- nrow(table)
plot(-4, xlim=c(2, lim-1), ylim=c(lim-1, 2), xaxt="n", yaxt="n", xlab="", ylab="")

for (i in 1: lim){ # get column
	for (k in 1: lim){ # plot row
		rect(i-0.5, k-0.5, i+0.5, k+0.5, col= col[table[k, i]+1], border=NA)
		text(i, k, table[k, i])
	}
	
}

# primer names including wobble possibilities
name <- NULL
for (i in 1:nrow(save)){
name[i] <- paste(save[i,1], "_", paste(save[i, 3:ncol(save)], sep="", collapse=""), sep="", collapse="")}


axis(1, at=1:lim, name, las=2, family="mono")
axis(2, at=1:lim, name, las=1, family="mono")

# circle primers!

primernames <- as.vector(save[,1])
unique <- unique(primernames)

for (k in 1:length(unique)){
x <- range(which(primernames == unique[k]))
for (i in 1:length(unique)){
y <- range(which(primernames == unique[i]))
rect(x[1]-0.5, y[2]+0.5, x[2]+0.5, y[1]-0.5, lwd=1.5)
}}

dev.off()







